import java.util.ArrayList;

import processing.core.*;
import processing.serial.*;

public class distanceMeasure extends PApplet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	Serial myPort;
	int myPortNumber = 9600;
	
	ArrayList<Float> values_one = new ArrayList<Float>();
	ArrayList<Float> values_two = new ArrayList<Float>();
	ArrayList<Float> values_three = new ArrayList<Float>();
	ArrayList<Float> values_four = new ArrayList<Float>();
	int maxItems = 200;
	
	public float difference = 25;
	
	public static void main(String args[]) {
		PApplet.main(new String[] { "distanceMeasure" });
	}
	
	public void setup() {
		smooth();
		size(800,1024);
		background(0);
		
		myPort = new Serial(this, "COM6", myPortNumber);//Serial.list()[0]
		myPort.bufferUntil('\n');
	}

	public void serialEvent(Serial myPort) {
		try {
			String inString = trim(myPort.readStringUntil('\n'));
			if(
				(inString != "")&&
				(inString != null)
					){
				if(inString.contains(":")){
					String[] double_value = inString.split(":");
					String[] line_value = double_value[1].split("\n");
					String[] space_value = line_value[0].split(" ");
					if(space_value[0].length() < 4){
						boolean goodNumber = true;
						for(int i=0; i<space_value[0].length(); i++){
							String tchar = space_value[0].substring(i, i+1);
							if(
								(!tchar.equalsIgnoreCase("1"))&&
								(!tchar.equalsIgnoreCase("2"))&&
								(!tchar.equalsIgnoreCase("3"))&&
								(!tchar.equalsIgnoreCase("4"))&&
								(!tchar.equalsIgnoreCase("5"))&&
								(!tchar.equalsIgnoreCase("6"))&&
								(!tchar.equalsIgnoreCase("7"))&&
								(!tchar.equalsIgnoreCase("8"))&&
								(!tchar.equalsIgnoreCase("9"))&&
								(!tchar.equalsIgnoreCase("0"))
									){
								goodNumber = false;
							}
						}
						if(goodNumber){
							float tFloat = Float.parseFloat(space_value[0]);
							int tInt = (Integer.parseInt(double_value[0]));
							if(tFloat>0){
								switch(tInt){
									case 1:
										if(values_one.size()>maxItems){values_one.remove(0);}
										values_one.add(tFloat);
									break;
									case 2:
										if(values_two.size()>maxItems){values_two.remove(0);}
										values_two.add(tFloat);
									break;
									case 3:
										if(values_three.size()>maxItems){values_three.remove(0);}
										values_three.add(tFloat);
									break;
									case 4:
										if(values_four.size()>maxItems){values_four.remove(0);}
										values_four.add(tFloat);
									break;
								}
							}
						}
					}
				}
			}
		} catch (Exception e) {
		    println("Initialization exception");
		} 
	}

	public void draw() {
		boolean hit_one = false;
		boolean hit_two = false;
		boolean hit_three = false;
		boolean hit_four = false;
		background(255);
		noStroke();
		fill(0,0,0);
		if(!values_one.isEmpty()){
			for(int i=0; i<values_one.size(); i++){
				ellipse(i, values_one.get(i), 5, 5);
			}
			if(abs(abs(values_one.get(values_one.size()-1))-512)>difference){
				hit_one = true;
			}
		}
		fill(0,0,255);
		if(!values_two.isEmpty()){
			for(int i=0; i<values_two.size(); i++){
				ellipse(i+200, values_two.get(i), 5, 5);
			}
			if(abs(abs(values_two.get(values_two.size()-1))-512)>difference){
				hit_two = true;
			}
			println(abs(abs(values_two.get(values_two.size()-1))-512));
		}
		fill(0,255,0);
		if(!values_three.isEmpty()){
			for(int i=0; i<values_three.size(); i++){
				ellipse(i+400, values_three.get(i), 5, 5);
			}
			if(abs(abs(values_three.get(values_three.size()-1))-512)>difference){
				hit_three = true;
			}
		}
		fill(255,0,0);
		if(!values_four.isEmpty()){
			for(int i=0; i<values_four.size(); i++){
				ellipse(i+600, values_four.get(i), 5, 5);
			}
			if(abs(abs(values_four.get(values_four.size()-1))-512)>difference){
				hit_four = true;
			}
		}
		
		fill(0);
		stroke(255);
		
		if(hit_one && hit_three){
			//right side
			rect(150,75,50,50);
		}
		
		if(hit_three && hit_two){
			//in front far
			rect(100,50,50,50);
		}
		
		if(hit_one && hit_four){
			//in front close
			rect(100,100,50,50);
		}
		
		if(hit_two && hit_four){
			//left side
			rect(50,75,50,50);
		}
		
		noStroke();
		
	}
	
}
